;
; hello ftdi blink ASM
; cedric doutriaux

.include "tn44def.inc"

.equ ledpin = PB2; led pin
.equ led_port = PORTB; led port
.equ led_dir = DDRB; led direction
.equ delay_value=255 ; delay time in cycles 

.def temp = R17; temporary storage
.def temp1 = R18; temporary storage
.def temp2 = R19; temporary storage
.def temp3 = R20; temporary storage

.cseg
.org 0; boot
rjmp reset




delai:
	mov r16,temp
	outer_loop:; duration ~
 

		ldi r26, 0; set r26 to zero
		ldi r27, 0; set r27 to zero
		delay_loop:;~262143*65535+3= 17179541508 cycles
			adiw r26, 1; add 1 to r26 and r27
			ldi r28, 0; set r28 to zero 
			ldi r29, 0; set r29 to zero
			delay_loop1:;~4*65535+3= 262143 cycles
				adiw r28, 1; add 1 to r28 and r29; 2 cycles
				brne delay_loop1; if no overflow loop; 1 or 2 cycles
			brne delay_loop; if no overflow loop
 
		dec r16; dcrement R16
		brne outer_loop; if no overflow loop
	ret


;
; main program
;
reset:

   ; set fuse low byte to 0x7E for 20 MHz resonator
   ;
   ; set clock divider to /1
   ;
   ldi temp, (1 << CLKPCE)
   ldi temp1, (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0)
   ;ldi temp1, (1 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);/256 : NEVER do that !!!!!otherwise use -B 1024 option with avrdude
   out CLKPR, temp
   out CLKPR, temp1
   ;
   ; set stack pointer to top of RAM
   ;
   ldi temp, high(RAMEND)
   out SPH, temp
   ldi temp, low(RAMEND)
   out SPL, temp
   ;
   ; init led pin as input
   ;
   ;sbi = Set Bit in I/O Register 
   ;
   sbi led_port,ledpin
   sbi led_dir,ledpin
   ;
   ; start main loop
   ;
   loop:
	sbi led_port,ledpin; led ON
	ldi temp,100;delay 1 sec
        rcall delai; delay
	cbi led_port,ledpin; led OFF
        ldi temp,50;delay 0.5sec
        rcall delai; delay        
	rjmp loop; relative jump to loop
